Subject: Re: [BUG] net_cls: Panic occured when net_cls subsystem use

From: Jarek Poplawski <[email-masked]>
Date: Sat, 30 May 2009 16:00:06 +0200

On Sat, May 30, 2009 at 09:31:37AM -0400, jamal wrote:
> On Sat, 2009-05-30 at 15:20 +0200, Jarek Poplawski wrote:
> 
> > Yes it oopses in cls_cgroup_classify(). Here is the first report:
> > http://permalink.gmane.org/gmane.linux.network/128593
> > 
> 
> Oopsing in classify is after the fact though. It should not have been
> linked to begin with (because wrong config was passed from user space).
> As far as cls_group is concerned that is an illegitimate config - thats
> why it failed it.
> 
> What were you suggesting to change in cls_group to avoid this oops?

I think checking the head (tp->root) for NULL like in cls_fw or
cls_route should work.

> 
> > We add/link unconfigured tp, but it could be destroyed later, so I
> > wouldn't call this a memory leak.
> 
> Indeed - call it "We add/link unconfigured tp".

Anyway, it's worked for other classifiers like this for some time...

> Anyways, a nice sun just came out over here and i am off to run 
> some chores. If you respond you will hear from me in a few hours.

Sure, we could probably stop this till Monday.

Cheers,
Jarek P.